// AB2.java

import java.awt.*;
import javax.swing.*;

import com.jgoodies.forms.builder.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

public class AB2 extends JFrame
{
   public AB2 ()
   {
      super ("Address Book");

      setDefaultCloseOperation (EXIT_ON_CLOSE);

      getContentPane ().add (buildGUI ());

      pack ();

      setVisible (true);
   }

   public JPanel buildGUI ()
   {
      FormLayout layout = new FormLayout ("left:pref, 2dlu, pref, 2dlu, " +
                                          "pref, 2dlu, pref:grow",
                                          "pref, 3dlu, pref, 3dlu, pref, " +
                                          "3dlu, pref, 3dlu, pref, 3dlu, " +
                                          "pref, 3dlu, pref");
      PanelBuilder builder = new PanelBuilder (layout);
      builder.setBorder (BorderFactory.createEmptyBorder (10, 10, 10, 10));
      CellConstraints cc = new CellConstraints ();

      JLabel lblName = builder.addLabel ("&Name:", cc.xy (1, 1));
      JTextField txtName = new JTextField (25);
      lblName.setLabelFor (txtName);
      builder.add (txtName, cc.xyw (3, 1, 5));

      JLabel lblAddress = builder.addLabel ("&Address:", cc.xy (1, 3));
      JTextField txtAddress = new JTextField (25);
      lblAddress.setLabelFor (txtAddress);
      builder.add (txtAddress, cc.xyw (3, 3, 5));

      JLabel lblCity = builder.addLabel ("&City:", cc.xy (1, 5));
      JTextField txtCity = new JTextField (25);
      lblCity.setLabelFor (txtCity);
      builder.add (txtCity, cc.xyw (3, 5, 5));

      JLabel lblRegion = builder.addLabel ("&Region:", cc.xy (1, 7));
      JTextField txtRegion = new JTextField (25);
      lblRegion.setLabelFor (txtRegion);
      builder.add (txtRegion, cc.xyw (3, 7, 5));

      JLabel lblCountry = builder.addLabel ("C&ountry:", cc.xy (1, 9));
      String [] countries = { "Brazil", "Ireland", "Sweden" };
      JComboBox cbCountry = new JComboBox (countries);
      lblCountry.setLabelFor (cbCountry);
      builder.add (cbCountry, cc.xyw (3, 9, 5));

      JLabel lblPhone = builder.addLabel ("&Phone:", cc.xy (1, 11));
      JTextField txtAreaCode = new JTextField (3);
      JTextField txtPrefixCode = new JTextField (3);
      JTextField txtNumber = new JTextField (4);
      lblPhone.setLabelFor (txtAreaCode);
      builder.add (txtAreaCode, cc.xy (3, 11));
      builder.add (txtPrefixCode, cc.xy (5, 11));
      builder.add (txtNumber, cc.xy (7, 11,
                   CellConstraints.LEFT, CellConstraints.DEFAULT));

      JButton btnOK = new JButton ("OK");
      JButton btnCancel = new JButton ("Cancel");
      builder.add (ButtonBarFactory.buildOKCancelBar (btnOK, btnCancel),
                   cc.xyw (1, 13, builder.getColumnCount ()));

      return builder.getPanel (); 
   }

   public static void main (String [] args)
   {
      new AB2 ();
   }
}
