// AB3.java

import java.awt.*;
import javax.swing.*;

import com.jgoodies.forms.builder.*;
import com.jgoodies.forms.debug.*;
import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

public class AB3 extends JFrame
{
   public static boolean fDebugEnabled = false;

   public AB3 ()
   {
      super ("Address Book");

      setDefaultCloseOperation (EXIT_ON_CLOSE);

      JPanel panel = buildGUI ();
      getContentPane ().add (panel);

      pack ();

      if (fDebugEnabled)
          FormDebugUtils.dumpAll (panel);

      setVisible (true);
   }

   public JPanel buildGUI ()
   {
      FormLayout layout = new FormLayout ("l:p, 2dlu, p, 2dlu, " +
                                          "p, 2dlu, p, 2dlu, p:g", "");
      DefaultFormBuilder builder;
      if (fDebugEnabled)
          builder = new DefaultFormBuilder (layout,
                                            new FormDebugPanel ());
      else
          builder = new DefaultFormBuilder (layout);
      builder.setBorder (BorderFactory.createEmptyBorder (10, 10, 10, 10));

      JTextField txtName = new JTextField (25);
      builder.append ("&Name:", txtName, 7);

      JTextField txtAddress = new JTextField (25);
      builder.append ("&Address:", txtAddress, 7);

      JTextField txtCity = new JTextField (25);
      builder.append ("&City:", txtCity, 7);

      JTextField txtRegion = new JTextField (25);
      builder.append ("&Region:", txtRegion, 7);

      String [] countries = { "Brazil", "Ireland", "Sweden" };
      JComboBox cbCountry = new JComboBox (countries);
      builder.append ("C&ountry:", cbCountry, 7);

      JTextField txtAreaCode = new JTextField (3);
      JTextField txtPrefixCode = new JTextField (3);
      JTextField txtNumber = new JTextField (4);
      builder.append ("&Phone:", txtAreaCode);
      builder.append (txtPrefixCode);
      builder.append (txtNumber);
      builder.nextLine ();

      JButton btnOK = new JButton ("OK");
      JButton btnCancel = new JButton ("Cancel");
      builder.append (ButtonBarFactory.buildOKCancelBar (btnOK, btnCancel),
                      builder.getColumnCount ());

      return builder.getPanel (); 
   }

   public static void main (String [] args)
   {
      if (args.length != 0)
          fDebugEnabled = true;

      new AB3 ();
   }
}
