// GBLDemo.java

import java.awt.*;
import javax.swing.*;

public class GBLDemo extends JFrame
{
   public GBLDemo (int demo)
   {
      super ("GridBagLayout Demo");

      setDefaultCloseOperation (EXIT_ON_CLOSE);

      JPanel panel;

      switch (demo)
      {
         default:
         case  1: panel = buildGUI1 ();
                  break;

         case  2: panel = buildGUI2 ();
                  break;

         case  3: panel = buildGUI3 ();
                  break;

         case  4: panel = buildGUI4 ();
                  break;

         case  5: panel = buildGUI5 ();
                  break;

         case  6: panel = buildGUI6 ();
                  break;

         case  7: panel = buildGUI7 ();
                  break;

         case  8: panel = buildGUI8 ();
                  break;

         case  9: panel = buildGUI9 ();
                  break;

         case 10: panel = buildGUI10 ();
      }

      getContentPane ().add (panel);

      pack ();

      setVisible (true);
   }

   public JPanel buildGUI1 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Place six buttons in a 2-row by 3-column grid. The first assignment
      // places "Button 1" in the grid's origin cell.

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 2");
      gbc.gridx = 1;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("?");
      gbc.gridx = 1;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI2 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.ipadx = 10;
      gbc.ipady = 10;

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 2");
      gbc.gridx = 1;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("?");
      gbc.gridx = 1;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI3 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 2");
      gbc.gridx = 1;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("?");
      gbc.gridx = 1;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI4 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 2");
      gbc.gridx = 1;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      gbc.gridwidth = GridBagConstraints.RELATIVE;
      gbc.fill = GridBagConstraints.HORIZONTAL;
      panel.add (button, gbc);

      // Reset to defaults.

      gbc.gridwidth = 1;
      gbc.fill = GridBagConstraints.NONE;

      button = new JButton ("?");
      gbc.gridx = GridBagConstraints.RELATIVE;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI5 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 2");
      gbc.gridx = 1;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      gbc.gridwidth = GridBagConstraints.REMAINDER;
      gbc.fill = GridBagConstraints.HORIZONTAL;
      panel.add (button, gbc);

      // Reset to defaults.

      gbc.gridwidth = 1;
      gbc.fill = GridBagConstraints.NONE;

      button = new JButton ("?");
      gbc.gridx = GridBagConstraints.RELATIVE;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI6 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      gbc.gridwidth = 2;
      panel.add (button, gbc);

      // Reset to defaults.

      gbc.gridwidth = 1;

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("?");
      gbc.gridx = 1;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI7 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      gbc.gridwidth = 2;
      panel.add (button, gbc);

      // Reset to defaults.

      gbc.gridwidth = 1;

      button = new JButton ("Button 2");
      gbc.gridx = 1;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("?");
      gbc.gridx = 1;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI8 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      gbc.gridwidth = 2;
      gbc.gridheight = 2;
      gbc.fill = GridBagConstraints.BOTH;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI9 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      gbc.gridwidth = 2;
      gbc.gridheight = 2;
      gbc.fill = GridBagConstraints.BOTH;
      panel.add (button, gbc);

      // Reset to defaults.

      gbc.gridwidth = 1;
      gbc.gridheight = 1;
      gbc.fill = GridBagConstraints.NONE;

      button = new JButton ("Button 2");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 2;
      panel.add (button, gbc);

      button = new JButton ("Button 5");
      gbc.gridx = 1;
      gbc.gridy = 2;
      panel.add (button, gbc);

      return panel;
   }

   public JPanel buildGUI10 ()
   {
      JPanel panel = new JPanel ();
      panel.setLayout (new GridBagLayout ());
      GridBagConstraints gbc = new GridBagConstraints ();

      // Set global constraints.

      gbc.insets = new Insets (5, 5, 0, 0);
      gbc.weightx = 1.0;
      gbc.weighty = 1.0;

      JButton button = new JButton ("Button 1");
      gbc.gridx = 0;
      gbc.gridy = 0;
      gbc.gridwidth = 2;
      gbc.anchor = GridBagConstraints.LINE_END;
      panel.add (button, gbc);

      // Reset to defaults.

      gbc.gridwidth = 1;
      gbc.anchor = GridBagConstraints.CENTER;

      button = new JButton ("Button 3");
      gbc.gridx = 2;
      gbc.gridy = 0;
      panel.add (button, gbc);

      button = new JButton ("Button 4");
      gbc.gridx = 0;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("?");
      gbc.gridx = 1;
      gbc.gridy = 1;
      panel.add (button, gbc);

      button = new JButton ("Button 6");
      gbc.gridx = 2;
      gbc.gridy = 1;
      panel.add (button, gbc);

      return panel;
   }

   public static void main (String [] args)
   {
      if (args.length != 1)
      {
          System.err.println ("usage  : java GBLDemo x");
          System.err.println ("example: java GBLDemo 1");
          return;          
      }

      new GBLDemo (Integer.parseInt (args [0]));
   }
}
